%THIS PROGRAM SEARCH FOR THE DETERMINACY REGION (FIGURE 1)
%IN CALVO and ROTEMBERG MODEL WITH INVESTMENT AND FORWARD-CURRENT-LOOKING RULES
%STAGGERED PRICE W/WN CAPITAL ADJUSTMENT COST
%MATRIX IS 4X4 WITH 3 JUMP VARIABLES AND 1 PREDETERMINED VARIABLE
%The effect of returns to scale on determinacy.

%Modified by Kevin X.D. Huang on 12/12/12
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
A11=zeros(4,4);
B11=zeros(4,4);

A12=zeros(4,4);
B12=zeros(4,4);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
A21=zeros(4,4);
B21=zeros(4,4);

A22=zeros(4,4);
B22=zeros(4,4);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
A31=zeros(4,4);
B31=zeros(4,4);

A32=zeros(4,4);
B32=zeros(4,4);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
A41=zeros(4,4);
B41=zeros(4,4);

A42=zeros(4,4);
B42=zeros(4,4);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
epsilon=10;%elasticity of substitution between goods%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%TAGGGGGGGGGGGGGGGGGGGGGGGGG
alpha=0.33;%share of capital in production
%thetap=0.33;%frequency of price adjustment varies from 0.33 to 0.57 to 0.75%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%TAGGGGGGGGGGGGGGGGGGGGGGGGG
rho=0.99;%quarterly discount rate
sigma=2;%relative risk aversion in consumption
delta=0.02;%steady state capital depreciation rate
deltatilde=1-rho*(1-delta);
eta=1;%inverse of labor supply elasticity
epsilonq=0;%elasticity of capital adjustment cost
thetap=0.57;%degree of stickiness of Calvo
gamma=30.424;%degree of stickiness of Rotemberg
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%TAGGGGGGGGG
%lambdacalvo=(1-thetap)*(1-beta*thetap)/thetap/(1+epsilon*(1-theta)/theta);
%lamadarot=(epsilon-1)/gamma;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%TAGGGGGGGGG
%epsilonq=0, 3;%elasticity of the investment to capital ratio to Tobin's q is 0 or 3%%%%%%%%%%%%%%TAGGGGGGGGGGGGGGGGGGGGGGGGG
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%gammac=(deltatilde-1)*sigma-epsilonq*rho*ck;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%TAGGGGGGGGG
%gamman=deltatilde*(eta+1)+epsilonq*rho*(1-alpha)*theta*ck;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%TAGGGGGGGGG
%gammak=-deltatilde+epsilonq*rho*(alpha*theta*(delta+ck)-delta)-epsilonq;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%TAGGGGGGGGG
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Ty=101;
Tpi=501;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%theta=0.67, Calvo
for ty=1:Ty;
    theta=0.67;
    ck=epsilon*deltatilde/(epsilon-1)/alpha/theta/rho-delta;
    lambdacalvo=(1-thetap)*(1-rho*thetap)/thetap/(1+epsilon*(1-theta)/theta);
    gammac=(deltatilde-1)*sigma-epsilonq*rho*ck;
    gamman=deltatilde*(eta+1)+epsilonq*rho*(1-alpha)*theta*(delta+ck);
    gammak=-deltatilde+epsilonq*rho*(alpha*theta*(delta+ck)-delta)-epsilonq;
    tauy=(ty-1)*0.01;
    L11(ty)=1;
    U11(ty)=1;
       for tpi=1:Tpi;
           taupi=(tpi-1)*0.01;
           minhelp=10000;
           maxhelp=0; 
             A11(1,1)=gammac;
             A11(1,2)=gammak;
             A11(1,3)=gamman;
             B11(1,1)=-sigma;
             B11(1,2)=-epsilonq;
             A11(2,2)=1;
             B11(2,1)=-ck;
             B11(2,2)=alpha*theta*(delta+ck)+1-delta;
             B11(2,3)=(1-alpha)*theta*(delta+ck);
             A11(3,4)=rho;
             B11(3,1)=-lambdacalvo*sigma;
             B11(3,2)=alpha*theta*lambdacalvo;
             B11(3,3)=-lambdacalvo*(1+eta-(1-alpha)*theta);
             B11(3,4)=1;
             A11(4,1)=sigma;
             A11(4,4)=1-taupi;
             B11(4,1)=sigma;
             B11(4,2)=alpha*theta*tauy;
             B11(4,3)=(1-alpha)*theta*tauy;
             M11=inv(A11)*B11;
             [P11,MU11]=eig(M11);
             E11=sort(abs(diag(MU11)));
                 if sum(E11<1)==1 & sum(E11>1)==3;
                    minhelp=taupi;
                    maxhelp=taupi;
                 else
                    minhelp=10001;
                    maxhelp=-1;
                 end;
                 if minhelp<=L11(ty);
                    L11(ty)=minhelp;
                 end;
                 if maxhelp>=U11(ty);
                    U11(ty)=maxhelp;
                 end;
       end;
end;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%theta=0.67, Rotemberg
for ty=1:Ty;
    theta=0.67;
    ck=epsilon*deltatilde/(epsilon-1)/alpha/theta/rho-delta;
    lamadarot=(epsilon-1)/gamma;
    gammac=(deltatilde-1)*sigma-epsilonq*rho*ck;
    gamman=deltatilde*(eta+1)+epsilonq*rho*(1-alpha)*theta*(delta+ck);
    gammak=-deltatilde+epsilonq*rho*(alpha*theta*(delta+ck)-delta)-epsilonq;
    tauy=(ty-1)*0.01;
    L12(ty)=1;
    U12(ty)=1;
       for tpi=1:Tpi;
           taupi=(tpi-1)*0.01;
           minhelp=10000;
           maxhelp=0; 
             A12(1,1)=gammac;
             A12(1,2)=gammak;
             A12(1,3)=gamman;
             B12(1,1)=-sigma;
             B12(1,2)=-epsilonq;
             A12(2,2)=1;
             B12(2,1)=-ck;
             B12(2,2)=alpha*theta*(delta+ck)+1-delta;
             B12(2,3)=(1-alpha)*theta*(delta+ck);
             A12(3,4)=rho;
             B12(3,1)=-lamadarot*sigma;
             B12(3,2)=alpha*theta*lamadarot;
             B12(3,3)=-lamadarot*(1+eta-(1-alpha)*theta);
             B12(3,4)=1;
             A12(4,1)=sigma;
             A12(4,4)=1-taupi;
             B12(4,1)=sigma;
             B12(4,2)=alpha*theta*tauy;
             B12(4,3)=(1-alpha)*theta*tauy;
             M12=inv(A12)*B12;
             [P12,MU12]=eig(M12);
             E12=sort(abs(diag(MU12)));
                 if sum(E12<1)==1 & sum(E12>1)==3;
                    minhelp=taupi;
                    maxhelp=taupi;
                 else
                    minhelp=10001;
                    maxhelp=-1;
                 end;
                 if minhelp<=L12(ty);
                    L12(ty)=minhelp;
                 end;
                 if maxhelp>=U12(ty);
                    U12(ty)=maxhelp;
                 end;
       end;
end;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%theta=1, Calvo
for ty=1:Ty;
    theta=1;
    ck=epsilon*deltatilde/(epsilon-1)/alpha/theta/rho-delta;
    lambdacalvo=(1-thetap)*(1-rho*thetap)/thetap/(1+epsilon*(1-theta)/theta);
    gammac=(deltatilde-1)*sigma-epsilonq*rho*ck;
    gamman=deltatilde*(eta+1)+epsilonq*rho*(1-alpha)*theta*(delta+ck);
    gammak=-deltatilde+epsilonq*rho*(alpha*theta*(delta+ck)-delta)-epsilonq;
    tauy=(ty-1)*0.01;
    L21(ty)=1;
    U21(ty)=1;
       for tpi=1:Tpi;
           taupi=(tpi-1)*0.01;
           minhelp=10000;
           maxhelp=0; 
             A21(1,1)=gammac;
             A21(1,2)=gammak;
             A21(1,3)=gamman;
             B21(1,1)=-sigma;
             B21(1,2)=-epsilonq;
             A21(2,2)=1;
             B21(2,1)=-ck;
             B21(2,2)=alpha*theta*(delta+ck)+1-delta;
             B21(2,3)=(1-alpha)*theta*(delta+ck);
             A21(3,4)=rho;
             B21(3,1)=-lambdacalvo*sigma;
             B21(3,2)=alpha*theta*lambdacalvo;
             B21(3,3)=-lambdacalvo*(1+eta-(1-alpha)*theta);
             B21(3,4)=1;
             A21(4,1)=sigma;
             A21(4,4)=1-taupi;
             B21(4,1)=sigma;
             B21(4,2)=alpha*theta*tauy;
             B21(4,3)=(1-alpha)*theta*tauy;
             M21=inv(A21)*B21;
             [P21,MU21]=eig(M21);
             E21=sort(abs(diag(MU21)));
                 if sum(E21<1)==1 & sum(E21>1)==3;
                    minhelp=taupi;
                    maxhelp=taupi;
                 else
                    minhelp=10001;
                    maxhelp=-1;
                 end;
                 if minhelp<=L21(ty);
                    L21(ty)=minhelp;
                 end;
                 if maxhelp>=U21(ty);
                    U21(ty)=maxhelp;
                 end;
       end;
end;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%theta=1, Rotemberg
for ty=1:Ty;
    theta=1;
    ck=epsilon*deltatilde/(epsilon-1)/alpha/theta/rho-delta;
    lamadarot=(epsilon-1)/gamma;
    gammac=(deltatilde-1)*sigma-epsilonq*rho*ck;
    gamman=deltatilde*(eta+1)+epsilonq*rho*(1-alpha)*theta*(delta+ck);
    gammak=-deltatilde+epsilonq*rho*(alpha*theta*(delta+ck)-delta)-epsilonq;
    tauy=(ty-1)*0.01;
    L22(ty)=1;
    U22(ty)=1;
       for tpi=1:Tpi;
           taupi=(tpi-1)*0.01;
           minhelp=10000;
           maxhelp=0; 
             A22(1,1)=gammac;
             A22(1,2)=gammak;
             A22(1,3)=gamman;
             B22(1,1)=-sigma;
             B22(1,2)=-epsilonq;
             A22(2,2)=1;
             B22(2,1)=-ck;
             B22(2,2)=alpha*theta*(delta+ck)+1-delta;
             B22(2,3)=(1-alpha)*theta*(delta+ck);
             A22(3,4)=rho;
             B22(3,1)=-lamadarot*sigma;
             B22(3,2)=alpha*theta*lamadarot;
             B22(3,3)=-lamadarot*(1+eta-(1-alpha)*theta);
             B22(3,4)=1;
             A22(4,1)=sigma;
             A22(4,4)=1-taupi;
             B22(4,1)=sigma;
             B22(4,2)=alpha*theta*tauy;
             B22(4,3)=(1-alpha)*theta*tauy;
             M22=inv(A22)*B22;
             [P22,MU22]=eig(M22);
             E22=sort(abs(diag(MU22)));
                 if sum(E22<1)==1 & sum(E22>1)==3;
                    minhelp=taupi;
                    maxhelp=taupi;
                 else
                    minhelp=10001;
                    maxhelp=-1;
                 end;
                 if minhelp<=L22(ty);
                    L22(ty)=minhelp;
                 end;
                 if maxhelp>=U22(ty);
                    U22(ty)=maxhelp;
                 end;
       end;
end;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%theta=1.1, Calvo
for ty=1:Ty;
    theta=1.1;
    ck=epsilon*deltatilde/(epsilon-1)/alpha/theta/rho-delta;
    lambdacalvo=(1-thetap)*(1-rho*thetap)/thetap/(1+epsilon*(1-theta)/theta);
    gammac=(deltatilde-1)*sigma-epsilonq*rho*ck;
    gamman=deltatilde*(eta+1)+epsilonq*rho*(1-alpha)*theta*(delta+ck);
    gammak=-deltatilde+epsilonq*rho*(alpha*theta*(delta+ck)-delta)-epsilonq;
    tauy=(ty-1)*0.01;
    L31(ty)=1;
    U31(ty)=1;
       for tpi=1:Tpi;
           taupi=(tpi-1)*0.01;
           minhelp=10000;
           maxhelp=0; 
            A31(1,1)=gammac;
             A31(1,2)=gammak;
             A31(1,3)=gamman;
             B31(1,1)=-sigma;
             B31(1,2)=-epsilonq;
             A31(2,2)=1;
             B31(2,1)=-ck;
             B31(2,2)=alpha*theta*(delta+ck)+1-delta;
             B31(2,3)=(1-alpha)*theta*(delta+ck);
             A31(3,4)=rho;
             B31(3,1)=-lambdacalvo*sigma;
             B31(3,2)=alpha*theta*lambdacalvo;
             B31(3,3)=-lambdacalvo*(1+eta-(1-alpha)*theta);
             B31(3,4)=1;
             A31(4,1)=sigma;
             A31(4,4)=1-taupi;
             B31(4,1)=sigma;
             B31(4,2)=alpha*theta*tauy;
             B31(4,3)=(1-alpha)*theta*tauy;
             M31=inv(A31)*B31;
             [P31,MU31]=eig(M31);
             E31=sort(abs(diag(MU31)));
                 if sum(E31<1)==1 & sum(E31>1)==3;
                    minhelp=taupi;
                    maxhelp=taupi;
                 else
                    minhelp=10001;
                    maxhelp=-1;
                 end;
                 if minhelp<=L31(ty);
                    L31(ty)=minhelp;
                 end;
                 if maxhelp>=U31(ty);
                    U31(ty)=maxhelp;
                 end;
       end;
end;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%theta=1.1, Rotemberg
for ty=1:Ty;
    theta=1.1;
    ck=epsilon*deltatilde/(epsilon-1)/alpha/theta/rho-delta;
    lamadarot=(epsilon-1)/gamma;
    gammac=(deltatilde-1)*sigma-epsilonq*rho*ck;
    gamman=deltatilde*(eta+1)+epsilonq*rho*(1-alpha)*theta*(delta+ck);
    gammak=-deltatilde+epsilonq*rho*(alpha*theta*(delta+ck)-delta)-epsilonq;
    tauy=(ty-1)*0.01;
    L32(ty)=1;
    U32(ty)=1;
       for tpi=1:Tpi;
           taupi=(tpi-1)*0.01;
           minhelp=10000;
           maxhelp=0; 
             A32(1,1)=gammac;
             A32(1,2)=gammak;
             A32(1,3)=gamman;
             B32(1,1)=-sigma;
             B32(1,2)=-epsilonq;
             A32(2,2)=1;
             B32(2,1)=-ck;
             B32(2,2)=alpha*theta*(delta+ck)+1-delta;
             B32(2,3)=(1-alpha)*theta*(delta+ck);
             A32(3,4)=rho;
             B32(3,1)=-lamadarot*sigma;
             B32(3,2)=alpha*theta*lamadarot;
             B32(3,3)=-lamadarot*(1+eta-(1-alpha)*theta);
             B32(3,4)=1;
             A32(4,1)=sigma;
             A32(4,4)=1-taupi;
             B32(4,1)=sigma;
             B32(4,2)=alpha*theta*tauy;
             B32(4,3)=(1-alpha)*theta*tauy;
             M32=inv(A32)*B32;
             [P32,MU32]=eig(M32);
             E32=sort(abs(diag(MU32)));
                 if sum(E32<1)==1 & sum(E32>1)==3;
                    minhelp=taupi;
                    maxhelp=taupi;
                 else
                    minhelp=10001;
                    maxhelp=-1;
                 end;
                 if minhelp<=L32(ty);
                    L32(ty)=minhelp;
                 end;
                 if maxhelp>=U32(ty);
                    U32(ty)=maxhelp;
                 end;
       end;
end;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ty=1:Ty;
subplot(3,2,2);
plot((ty-1)*0.01,U11(ty),'-',(ty-1)*0.01,L11(ty),'--');
axis([0,1,0,5]);
set(gca,'xtick',[0,0.2,0.4,0.6,0.8,1]);
set(gca,'ytick',[0,1,2,3,4,5]);
title('Calvo Model');


subplot(3,2,1);
plot((ty-1)*0.01,U12(ty),'-',(ty-1)*0.01,L12(ty),'--');
axis([0,1,0,5]);
set(gca,'xtick',[0,0.2,0.4,0.6,0.8,1]);
set(gca,'ytick',[0,1,2,3,4,5]);
title('Rotemberg Model');
ylabel('\theta=0.67');
text(0.5,1.65,'D region');

subplot(3,2,4);
plot((ty-1)*0.01,U21(ty),'-',(ty-1)*0.01,L21(ty),'--');
axis([0,1,0,5]);
set(gca,'xtick',[0,0.2,0.4,0.6,0.8,1]);
set(gca,'ytick',[0,1,2,3,4,5]);


subplot(3,2,3);
plot((ty-1)*0.01,U22(ty),'-',(ty-1)*0.01,L22(ty),'--');
axis([0,1,0,5]);
set(gca,'xtick',[0,0.2,0.4,0.6,0.8,1]);
set(gca,'ytick',[0,1,2,3,4,5]);
ylabel('\theta=1');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

subplot(3,2,6);
plot((ty-1)*0.01,U31(ty),'-',(ty-1)*0.01,L31(ty),'--');
axis([0,1,0,5]);
set(gca,'xtick',[0,0.2,0.4,0.6,0.8,1]);
set(gca,'ytick',[0,1,2,3,4,5]);

subplot(3,2,5);
plot((ty-1)*0.01,U32(ty),'-',(ty-1)*0.01,L32(ty),'--');
axis([0,1,0,5]);
set(gca,'xtick',[0,0.2,0.4,0.6,0.8,1]);
set(gca,'ytick',[0,1,2,3,4,5]);
ylabel('\theta=1.1');
