%THIS PROGRAM SEARCH FOR THE DETERMINACY REGION (FIGURE 2)
%IN CALVO and ROTEMBERG MODEL WITH INVESTMENT AND FORWARD-CURRENT-LOOKING RULES
%STAGGERED PRICE W/WN CAPITAL ADJUSTMENT COST
%MATRIX IS 4X4 WITH 3 JUMP VARIABLES AND 1 PREDETERMINED VARIABLE
%THE EFFECT OF MARKET POWER ON THE DETERMINACY

%Modified by Kevin X.D. Huang on 12/12/12
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
A11=zeros(4,4);
B11=zeros(4,4);

A12=zeros(4,4);
B12=zeros(4,4);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
A21=zeros(4,4);
B21=zeros(4,4);

A22=zeros(4,4);
B22=zeros(4,4);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
A31=zeros(4,4);
B31=zeros(4,4);

A32=zeros(4,4);
B32=zeros(4,4);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
A41=zeros(4,4);
B41=zeros(4,4);

A42=zeros(4,4);
B42=zeros(4,4);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
A51=zeros(4,4);
B51=zeros(4,4);

A52=zeros(4,4);
B52=zeros(4,4);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
A61=zeros(4,4);
B61=zeros(4,4);

A62=zeros(4,4);
B62=zeros(4,4);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
A71=zeros(4,4);
B71=zeros(4,4);

A72=zeros(4,4);
B72=zeros(4,4);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
A81=zeros(4,4);
B81=zeros(4,4);

A82=zeros(4,4);
B82=zeros(4,4);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
A91=zeros(4,4);
B91=zeros(4,4);

A92=zeros(4,4);
B92=zeros(4,4);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
alpha=0.33;%share of capital in production
%thetap=0.33;%frequency of price adjustment varies from 0.33 to 0.57 to 0.75%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%TAGGGGGGGGGGGGGGGGGGGGGGGGG
rho=0.99;%quarterly discount rate
sigma=2;%relative risk aversion in consumption
%eta=0;%relative risk aversion in labor is 0 or 10%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%TAGGGGGGGGGGGGGGGGGGGGGGGGG
delta=0.02;%steady state capital depreciation rate
deltatilde=1-rho*(1-delta);
eta=1;%inverse of labor supply elasticity
epsilonq=0;%elasticity of capital adjustment cost
thetap=0.57;%degree of stickiness of Calvo
gamma=30.424;%degree of stickiness of Rotemberg
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%TAGGGGGGGGG
%lambdacalvo=(1-thetap)*(1-beta*thetap)/thetap/(1+epsilon*(1-theta)/theta);
%lamadarot=(epsilon-1)/gamma;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%TAGGGGGGGGG
%epsilonq=3;%elasticity of the investment to capital ratio to Tobin's q is 0 or 3%%%%%%%%%%%%%%TAGGGGGGGGGGGGGGGGGGGGGGGGG
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%gammac=(deltatilde-1)*sigma-epsilonq*rho*ck;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%TAGGGGGGGGG
%gamman=deltatilde*(eta+1)+epsilonq*rho*(1-alpha)*theta*ck;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%TAGGGGGGGGG
%gammak=-deltatilde+epsilonq*rho*(alpha*theta*(delta+ck)-delta)-epsilonq;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%TAGGGGGGGGG
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Ty=21;
Tpi=503;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%theta=0.67, Calvo
theta=0.67;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%TAGGGGGGGGGGGGGGGGGGGGGGGGG
for ty=1:Ty;
    epsilon=4;
    ck=epsilon*deltatilde/(epsilon-1)/alpha/theta/rho-delta;
    lambdacalvo=(1-thetap)*(1-rho*thetap)/thetap/(1+epsilon*(1-theta)/theta);
    gammac=(deltatilde-1)*sigma-epsilonq*rho*ck;
    gamman=deltatilde*(eta+1)+epsilonq*rho*(1-alpha)*theta*(delta+ck);
    gammak=-deltatilde+epsilonq*rho*(alpha*theta*(delta+ck)-delta)-epsilonq;
    tauy=(ty-1)*0.05;
    L11(ty)=1;
    U11(ty)=1;
       for tpi=1:Tpi;
           taupi=(tpi-1)*0.01;
           minhelp=10000;
           maxhelp=0; 
             A11(1,1)=gammac;
             A11(1,2)=gammak;
             A11(1,3)=gamman;
             B11(1,1)=-sigma;
             B11(1,2)=-epsilonq;
             A11(2,2)=1;
             B11(2,1)=-ck;
             B11(2,2)=alpha*theta*(delta+ck)+1-delta;
             B11(2,3)=(1-alpha)*theta*(delta+ck);
             A11(3,4)=rho;
             B11(3,1)=-lambdacalvo*sigma;
             B11(3,2)=alpha*theta*lambdacalvo;
             B11(3,3)=-lambdacalvo*(1+eta-(1-alpha)*theta);
             B11(3,4)=1;
             A11(4,1)=sigma;
             A11(4,4)=1-taupi;
             B11(4,1)=sigma;
             B11(4,2)=alpha*theta*tauy;
             B11(4,3)=(1-alpha)*theta*tauy;
             M11=inv(A11)*B11;
             [P11,MU11]=eig(M11);
             E11=sort(abs(diag(MU11)));
                 if sum(E11<1)==1 & sum(E11>1)==3;
                    minhelp=taupi;
                    maxhelp=taupi;
                 else
                    minhelp=10001;
                    maxhelp=-1;
                 end;
                 if minhelp<=L11(ty);
                    L11(ty)=minhelp;
                 end;
                 if maxhelp>=U11(ty);
                    U11(ty)=maxhelp;
                 end;
       end;
end;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%theta=0.67, Rotemberg
for ty=1:Ty;
    epsilon=4;
    ck=epsilon*deltatilde/(epsilon-1)/alpha/theta/rho-delta;
    lamadarot=(epsilon-1)/gamma;
    gammac=(deltatilde-1)*sigma-epsilonq*rho*ck;
    gamman=deltatilde*(eta+1)+epsilonq*rho*(1-alpha)*theta*(delta+ck);
    gammak=-deltatilde+epsilonq*rho*(alpha*theta*(delta+ck)-delta)-epsilonq;
    tauy=(ty-1)*0.05;
    L12(ty)=1;
    U12(ty)=1;
       for tpi=1:Tpi;
           taupi=(tpi-1)*0.01;
           minhelp=10000;
           maxhelp=0; 
             A12(1,1)=gammac;
             A12(1,2)=gammak;
             A12(1,3)=gamman;
             B12(1,1)=-sigma;
             B12(1,2)=-epsilonq;
             A12(2,2)=1;
             B12(2,1)=-ck;
             B12(2,2)=alpha*theta*(delta+ck)+1-delta;
             B12(2,3)=(1-alpha)*theta*(delta+ck);
             A12(3,4)=rho;
             B12(3,1)=-lamadarot*sigma;
             B12(3,2)=alpha*theta*lamadarot;
             B12(3,3)=-lamadarot*(1+eta-(1-alpha)*theta);
             B12(3,4)=1;
             A12(4,1)=sigma;
             A12(4,4)=1-taupi;
             B12(4,1)=sigma;
             B12(4,2)=alpha*theta*tauy;
             B12(4,3)=(1-alpha)*theta*tauy;
             M12=inv(A12)*B12;
             [P12,MU12]=eig(M12);
             E12=sort(abs(diag(MU12)));
                 if sum(E12<1)==1 & sum(E12>1)==3;
                    minhelp=taupi;
                    maxhelp=taupi;
                 else
                    minhelp=10001;
                    maxhelp=-1;
                 end;
                 if minhelp<=L12(ty);
                    L12(ty)=minhelp;
                 end;
                 if maxhelp>=U12(ty);
                    U12(ty)=maxhelp;
                 end;
       end;
end;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   
%theta=0.67, Calvo
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for ty=1:Ty;
    epsilon=10;
    ck=epsilon*deltatilde/(epsilon-1)/alpha/theta/rho-delta;
    lambdacalvo=(1-thetap)*(1-rho*thetap)/thetap/(1+epsilon*(1-theta)/theta);
    gammac=(deltatilde-1)*sigma-epsilonq*rho*ck;
    gamman=deltatilde*(eta+1)+epsilonq*rho*(1-alpha)*theta*(delta+ck);
    gammak=-deltatilde+epsilonq*rho*(alpha*theta*(delta+ck)-delta)-epsilonq;
    tauy=(ty-1)*0.05;
    L21(ty)=1;
    U21(ty)=1;
       for tpi=1:Tpi;
           taupi=(tpi-1)*0.01;
           minhelp=10000;
           maxhelp=0; 
             A21(1,1)=gammac;
             A21(1,2)=gammak;
             A21(1,3)=gamman;
             B21(1,1)=-sigma;
             B21(1,2)=-epsilonq;
             A21(2,2)=1;
             B21(2,1)=-ck;
             B21(2,2)=alpha*theta*(delta+ck)+1-delta;
             B21(2,3)=(1-alpha)*theta*(delta+ck);
             A21(3,4)=rho;
             B21(3,1)=-lambdacalvo*sigma;
             B21(3,2)=alpha*theta*lambdacalvo;
             B21(3,3)=-lambdacalvo*(1+eta-(1-alpha)*theta);
             B21(3,4)=1;
             A21(4,1)=sigma;
             A21(4,4)=1-taupi;
             B21(4,1)=sigma;
             B21(4,2)=alpha*theta*tauy;
             B21(4,3)=(1-alpha)*theta*tauy;
             M21=inv(A21)*B21;
             [P21,MU21]=eig(M21);
             E21=sort(abs(diag(MU21)));
                 if sum(E21<1)==1 & sum(E21>1)==3;
                    minhelp=taupi;
                    maxhelp=taupi;
                 else
                    minhelp=10001;
                    maxhelp=-1;
                 end;
                 if minhelp<=L21(ty);
                    L21(ty)=minhelp;
                 end;
                 if maxhelp>=U21(ty);
                    U21(ty)=maxhelp;
                 end;
       end;
end;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
%theta=0.67, Rotemberg
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for ty=1:Ty;
    epsilon=10;
    ck=epsilon*deltatilde/(epsilon-1)/alpha/theta/rho-delta;
    lamadarot=(epsilon-1)/gamma;
    gammac=(deltatilde-1)*sigma-epsilonq*rho*ck;
    gamman=deltatilde*(eta+1)+epsilonq*rho*(1-alpha)*theta*(delta+ck);
    gammak=-deltatilde+epsilonq*rho*(alpha*theta*(delta+ck)-delta)-epsilonq;
    tauy=(ty-1)*0.05;
    L22(ty)=1;
    U22(ty)=1;
       for tpi=1:Tpi;
           taupi=(tpi-1)*0.01;
           minhelp=10000;
           maxhelp=0; 
             A22(1,1)=gammac;
             A22(1,2)=gammak;
             A22(1,3)=gamman;
             B22(1,1)=-sigma;
             B22(1,2)=-epsilonq;
             A22(2,2)=1;
             B22(2,1)=-ck;
             B22(2,2)=alpha*theta*(delta+ck)+1-delta;
             B22(2,3)=(1-alpha)*theta*(delta+ck);
             A22(3,4)=rho;
             B22(3,1)=-lamadarot*sigma;
             B22(3,2)=alpha*theta*lamadarot;
             B22(3,3)=-lamadarot*(1+eta-(1-alpha)*theta);
             B22(3,4)=1;
             A22(4,1)=sigma;
             A22(4,4)=1-taupi;
             B22(4,1)=sigma;
             B22(4,2)=alpha*theta*tauy;
             B22(4,3)=(1-alpha)*theta*tauy;
             M22=inv(A22)*B22;
             [P22,MU22]=eig(M22);
             E22=sort(abs(diag(MU22)));
                 if sum(E22<1)==1 & sum(E22>1)==3;
                    minhelp=taupi;
                    maxhelp=taupi;
                 else
                    minhelp=10001;
                    maxhelp=-1;
                 end;
                 if minhelp<=L22(ty);
                    L22(ty)=minhelp;
                 end;
                 if maxhelp>=U22(ty);
                    U22(ty)=maxhelp;
                 end;
       end;
end;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
%theta=0.67, Calvo
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for ty=1:Ty;
    epsilon=20;
    ck=epsilon*deltatilde/(epsilon-1)/alpha/theta/rho-delta;
    lambdacalvo=(1-thetap)*(1-rho*thetap)/thetap/(1+epsilon*(1-theta)/theta);
    gammac=(deltatilde-1)*sigma-epsilonq*rho*ck;
    gamman=deltatilde*(eta+1)+epsilonq*rho*(1-alpha)*theta*(delta+ck);
    gammak=-deltatilde+epsilonq*rho*(alpha*theta*(delta+ck)-delta)-epsilonq;
    tauy=(ty-1)*0.05;
    L31(ty)=1;
    U31(ty)=1;
       for tpi=1:Tpi;
           taupi=(tpi-1)*0.01;
           minhelp=10000;
           maxhelp=0; 
            A31(1,1)=gammac;
             A31(1,2)=gammak;
             A31(1,3)=gamman;
             B31(1,1)=-sigma;
             B31(1,2)=-epsilonq;
             A31(2,2)=1;
             B31(2,1)=-ck;
             B31(2,2)=alpha*theta*(delta+ck)+1-delta;
             B31(2,3)=(1-alpha)*theta*(delta+ck);
             A31(3,4)=rho;
             B31(3,1)=-lambdacalvo*sigma;
             B31(3,2)=alpha*theta*lambdacalvo;
             B31(3,3)=-lambdacalvo*(1+eta-(1-alpha)*theta);
             B31(3,4)=1;
             A31(4,1)=sigma;
             A31(4,4)=1-taupi;
             B31(4,1)=sigma;
             B31(4,2)=alpha*theta*tauy;
             B31(4,3)=(1-alpha)*theta*tauy;
             M31=inv(A31)*B31;
             [P31,MU31]=eig(M31);
             E31=sort(abs(diag(MU31)));
                 if sum(E31<1)==1 & sum(E31>1)==3;
                    minhelp=taupi;
                    maxhelp=taupi;
                 else
                    minhelp=10001;
                    maxhelp=-1;
                 end;
                 if minhelp<=L31(ty);
                    L31(ty)=minhelp;
                 end;
                 if maxhelp>=U31(ty);
                    U31(ty)=maxhelp;
                 end;
       end;
end;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%theta=0.67, Rotemberg
for ty=1:Ty;
    epsilon=20;
    ck=epsilon*deltatilde/(epsilon-1)/alpha/theta/rho-delta;
    lamadarot=(epsilon-1)/gamma;
    gammac=(deltatilde-1)*sigma-epsilonq*rho*ck;
    gamman=deltatilde*(eta+1)+epsilonq*rho*(1-alpha)*theta*(delta+ck);
    gammak=-deltatilde+epsilonq*rho*(alpha*theta*(delta+ck)-delta)-epsilonq;
    tauy=(ty-1)*0.05;
    L32(ty)=1;
    U32(ty)=1;
       for tpi=1:Tpi;
           taupi=(tpi-1)*0.01;
           minhelp=10000;
           maxhelp=0; 
             A32(1,1)=gammac;
             A32(1,2)=gammak;
             A32(1,3)=gamman;
             B32(1,1)=-sigma;
             B32(1,2)=-epsilonq;
             A32(2,2)=1;
             B32(2,1)=-ck;
             B32(2,2)=alpha*theta*(delta+ck)+1-delta;
             B32(2,3)=(1-alpha)*theta*(delta+ck);
             A32(3,4)=rho;
             B32(3,1)=-lamadarot*sigma;
             B32(3,2)=alpha*theta*lamadarot;
             B32(3,3)=-lamadarot*(1+eta-(1-alpha)*theta);
             B32(3,4)=1;
             A32(4,1)=sigma;
             A32(4,4)=1-taupi;
             B32(4,1)=sigma;
             B32(4,2)=alpha*theta*tauy;
             B32(4,3)=(1-alpha)*theta*tauy;
             M32=inv(A32)*B32;
             [P32,MU32]=eig(M32);
             E32=sort(abs(diag(MU32)));
                 if sum(E32<1)==1 & sum(E32>1)==3;
                    minhelp=taupi;
                    maxhelp=taupi;
                 else
                    minhelp=10001;
                    maxhelp=-1;
                 end;
                 if minhelp<=L32(ty);
                    L32(ty)=minhelp;
                 end;
                 if maxhelp>=U32(ty);
                    U32(ty)=maxhelp;
                 end;
       end;
end;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
%theta=1, Calvo
theta=1;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%TAGGGGGGGGGGGGGGGGGGGGGGGGG
for ty=1:Ty;
    epsilon=4;
    ck=epsilon*deltatilde/(epsilon-1)/alpha/theta/rho-delta;
    lambdacalvo=(1-thetap)*(1-rho*thetap)/thetap/(1+epsilon*(1-theta)/theta);
    gammac=(deltatilde-1)*sigma-epsilonq*rho*ck;
    gamman=deltatilde*(eta+1)+epsilonq*rho*(1-alpha)*theta*(delta+ck);
    gammak=-deltatilde+epsilonq*rho*(alpha*theta*(delta+ck)-delta)-epsilonq;
    tauy=(ty-1)*0.05;
    L41(ty)=1;
    U41(ty)=1;
       for tpi=1:Tpi;
           taupi=(tpi-1)*0.01;
           minhelp=10000;
           maxhelp=0; 
             A41(1,1)=gammac;
             A41(1,2)=gammak;
             A41(1,3)=gamman;
             B41(1,1)=-sigma;
             B41(1,2)=-epsilonq;
             A41(2,2)=1;
             B41(2,1)=-ck;
             B41(2,2)=alpha*theta*(delta+ck)+1-delta;
             B41(2,3)=(1-alpha)*theta*(delta+ck);
             A41(3,4)=rho;
             B41(3,1)=-lambdacalvo*sigma;
             B41(3,2)=alpha*theta*lambdacalvo;
             B41(3,3)=-lambdacalvo*(1+eta-(1-alpha)*theta);
             B41(3,4)=1;
             A41(4,1)=sigma;
             A41(4,4)=1-taupi;
             B41(4,1)=sigma;
             B41(4,2)=alpha*theta*tauy;
             B41(4,3)=(1-alpha)*theta*tauy;
             M41=inv(A41)*B41;
             [P41,MU41]=eig(M41);
             E41=sort(abs(diag(MU41)));
                 if sum(E41<1)==1 & sum(E41>1)==3;
                    minhelp=taupi;
                    maxhelp=taupi;
                 else
                    minhelp=10001;
                    maxhelp=-1;
                 end;
                 if minhelp<=L41(ty);
                    L41(ty)=minhelp;
                 end;
                 if maxhelp>=U41(ty);
                    U41(ty)=maxhelp;
                 end;
       end;
end;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%theta=1, Rotemberg
for ty=1:Ty;
    epsilon=4;
    ck=epsilon*deltatilde/(epsilon-1)/alpha/theta/rho-delta;
    lamadarot=(epsilon-1)/gamma;
    gammac=(deltatilde-1)*sigma-epsilonq*rho*ck;
    gamman=deltatilde*(eta+1)+epsilonq*rho*(1-alpha)*theta*(delta+ck);
    gammak=-deltatilde+epsilonq*rho*(alpha*theta*(delta+ck)-delta)-epsilonq;
    tauy=(ty-1)*0.05;
    L42(ty)=1;
    U42(ty)=1;
       for tpi=1:Tpi;
           taupi=(tpi-1)*0.01;
           minhelp=10000;
           maxhelp=0; 
             A42(1,1)=gammac;
             A42(1,2)=gammak;
             A42(1,3)=gamman;
             B42(1,1)=-sigma;
             B42(1,2)=-epsilonq;
             A42(2,2)=1;
             B42(2,1)=-ck;
             B42(2,2)=alpha*theta*(delta+ck)+1-delta;
             B42(2,3)=(1-alpha)*theta*(delta+ck);
             A42(3,4)=rho;
             B42(3,1)=-lamadarot*sigma;
             B42(3,2)=alpha*theta*lamadarot;
             B42(3,3)=-lamadarot*(1+eta-(1-alpha)*theta);
             B42(3,4)=1;
             A42(4,1)=sigma;
             A42(4,4)=1-taupi;
             B42(4,1)=sigma;
             B42(4,2)=alpha*theta*tauy;
             B42(4,3)=(1-alpha)*theta*tauy;
             M42=inv(A42)*B42;
             [P42,MU42]=eig(M42);
             E42=sort(abs(diag(MU42)));
                 if sum(E42<1)==1 & sum(E42>1)==3;
                    minhelp=taupi;
                    maxhelp=taupi;
                 else
                    minhelp=10001;
                    maxhelp=-1;
                 end;
                 if minhelp<=L42(ty);
                    L42(ty)=minhelp;
                 end;
                 if maxhelp>=U42(ty);
                    U42(ty)=maxhelp;
                 end;
       end;
end;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
%theta=1, Calvo
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for ty=1:Ty;
    epsilon=10;
    ck=epsilon*deltatilde/(epsilon-1)/alpha/theta/rho-delta;
    lambdacalvo=(1-thetap)*(1-rho*thetap)/thetap/(1+epsilon*(1-theta)/theta);
    gammac=(deltatilde-1)*sigma-epsilonq*rho*ck;
    gamman=deltatilde*(eta+1)+epsilonq*rho*(1-alpha)*theta*(delta+ck);
    gammak=-deltatilde+epsilonq*rho*(alpha*theta*(delta+ck)-delta)-epsilonq;
    tauy=(ty-1)*0.05;
    L51(ty)=1;
    U51(ty)=1;
       for tpi=1:Tpi;
           taupi=(tpi-1)*0.01;
           minhelp=10000;
           maxhelp=0; 
             A51(1,1)=gammac;
             A51(1,2)=gammak;
             A51(1,3)=gamman;
             B51(1,1)=-sigma;
             B51(1,2)=-epsilonq;
             A51(2,2)=1;
             B51(2,1)=-ck;
             B51(2,2)=alpha*theta*(delta+ck)+1-delta;
             B51(2,3)=(1-alpha)*theta*(delta+ck);
             A51(3,4)=rho;
             B51(3,1)=-lambdacalvo*sigma;
             B51(3,2)=alpha*theta*lambdacalvo;
             B51(3,3)=-lambdacalvo*(1+eta-(1-alpha)*theta);
             B51(3,4)=1;
             A51(4,1)=sigma;
             A51(4,4)=1-taupi;
             B51(4,1)=sigma;
             B51(4,2)=alpha*theta*tauy;
             B51(4,3)=(1-alpha)*theta*tauy;
             M51=inv(A51)*B51;
             [P51,MU51]=eig(M51);
             E51=sort(abs(diag(MU51)));
                 if sum(E51<1)==1 & sum(E51>1)==3;
                    minhelp=taupi;
                    maxhelp=taupi;
                 else
                    minhelp=10001;
                    maxhelp=-1;
                 end;
                 if minhelp<=L51(ty);
                    L51(ty)=minhelp;
                 end;
                 if maxhelp>=U51(ty);
                    U51(ty)=maxhelp;
                 end;
       end;
end;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
%theta=1, Rotemberg
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for ty=1:Ty;
    epsilon=10;
    ck=epsilon*deltatilde/(epsilon-1)/alpha/theta/rho-delta;
    lamadarot=(epsilon-1)/gamma;
    gammac=(deltatilde-1)*sigma-epsilonq*rho*ck;
    gamman=deltatilde*(eta+1)+epsilonq*rho*(1-alpha)*theta*(delta+ck);
    gammak=-deltatilde+epsilonq*rho*(alpha*theta*(delta+ck)-delta)-epsilonq;
    tauy=(ty-1)*0.05;
    L52(ty)=1;
    U52(ty)=1;
       for tpi=1:Tpi;
           taupi=(tpi-1)*0.01;
           minhelp=10000;
           maxhelp=0; 
             A52(1,1)=gammac;
             A52(1,2)=gammak;
             A52(1,3)=gamman;
             B52(1,1)=-sigma;
             B52(1,2)=-epsilonq;
             A52(2,2)=1;
             B52(2,1)=-ck;
             B52(2,2)=alpha*theta*(delta+ck)+1-delta;
             B52(2,3)=(1-alpha)*theta*(delta+ck);
             A52(3,4)=rho;
             B52(3,1)=-lamadarot*sigma;
             B52(3,2)=alpha*theta*lamadarot;
             B52(3,3)=-lamadarot*(1+eta-(1-alpha)*theta);
             B52(3,4)=1;
             A52(4,1)=sigma;
             A52(4,4)=1-taupi;
             B52(4,1)=sigma;
             B52(4,2)=alpha*theta*tauy;
             B52(4,3)=(1-alpha)*theta*tauy;
             M52=inv(A52)*B52;
             [P52,MU52]=eig(M52);
             E52=sort(abs(diag(MU52)));
                 if sum(E52<1)==1 & sum(E52>1)==3;
                    minhelp=taupi;
                    maxhelp=taupi;
                 else
                    minhelp=10001;
                    maxhelp=-1;
                 end;
                 if minhelp<=L52(ty);
                    L52(ty)=minhelp;
                 end;
                 if maxhelp>=U52(ty);
                    U52(ty)=maxhelp;
                 end;
       end;
end;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%theta=1, Calvo
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for ty=1:Ty;
    epsilon=20;
    ck=epsilon*deltatilde/(epsilon-1)/alpha/theta/rho-delta;
    lambdacalvo=(1-thetap)*(1-rho*thetap)/thetap/(1+epsilon*(1-theta)/theta);
    gammac=(deltatilde-1)*sigma-epsilonq*rho*ck;
    gamman=deltatilde*(eta+1)+epsilonq*rho*(1-alpha)*theta*(delta+ck);
    gammak=-deltatilde+epsilonq*rho*(alpha*theta*(delta+ck)-delta)-epsilonq;
    tauy=(ty-1)*0.05;
    L61(ty)=1;
    U61(ty)=1;
       for tpi=1:Tpi;
           taupi=(tpi-1)*0.01;
           minhelp=10000;
           maxhelp=0; 
            A61(1,1)=gammac;
             A61(1,2)=gammak;
             A61(1,3)=gamman;
             B61(1,1)=-sigma;
             B61(1,2)=-epsilonq;
             A61(2,2)=1;
             B61(2,1)=-ck;
             B61(2,2)=alpha*theta*(delta+ck)+1-delta;
             B61(2,3)=(1-alpha)*theta*(delta+ck);
             A61(3,4)=rho;
             B61(3,1)=-lambdacalvo*sigma;
             B61(3,2)=alpha*theta*lambdacalvo;
             B61(3,3)=-lambdacalvo*(1+eta-(1-alpha)*theta);
             B61(3,4)=1;
             A61(4,1)=sigma;
             A61(4,4)=1-taupi;
             B61(4,1)=sigma;
             B61(4,2)=alpha*theta*tauy;
             B61(4,3)=(1-alpha)*theta*tauy;
             M61=inv(A61)*B61;
             [P61,MU61]=eig(M61);
             E61=sort(abs(diag(MU61)));
                 if sum(E61<1)==1 & sum(E61>1)==3;
                    minhelp=taupi;
                    maxhelp=taupi;
                 else
                    minhelp=10001;
                    maxhelp=-1;
                 end;
                 if minhelp<=L61(ty);
                    L61(ty)=minhelp;
                 end;
                 if maxhelp>=U61(ty);
                    U61(ty)=maxhelp;
                 end;
       end;
end;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%theta=1, Rotemberg
for ty=1:Ty;
    epsilon=20;
    ck=epsilon*deltatilde/(epsilon-1)/alpha/theta/rho-delta;
    lamadarot=(epsilon-1)/gamma;
    gammac=(deltatilde-1)*sigma-epsilonq*rho*ck;
    gamman=deltatilde*(eta+1)+epsilonq*rho*(1-alpha)*theta*(delta+ck);
    gammak=-deltatilde+epsilonq*rho*(alpha*theta*(delta+ck)-delta)-epsilonq;
    tauy=(ty-1)*0.05;
    L62(ty)=1;
    U62(ty)=1;
       for tpi=1:Tpi;
           taupi=(tpi-1)*0.01;
           minhelp=10000;
           maxhelp=0; 
             A62(1,1)=gammac;
             A62(1,2)=gammak;
             A62(1,3)=gamman;
             B62(1,1)=-sigma;
             B62(1,2)=-epsilonq;
             A62(2,2)=1;
             B62(2,1)=-ck;
             B62(2,2)=alpha*theta*(delta+ck)+1-delta;
             B62(2,3)=(1-alpha)*theta*(delta+ck);
             A62(3,4)=rho;
             B62(3,1)=-lamadarot*sigma;
             B62(3,2)=alpha*theta*lamadarot;
             B62(3,3)=-lamadarot*(1+eta-(1-alpha)*theta);
             B62(3,4)=1;
             A62(4,1)=sigma;
             A62(4,4)=1-taupi;
             B62(4,1)=sigma;
             B62(4,2)=alpha*theta*tauy;
             B62(4,3)=(1-alpha)*theta*tauy;
             M62=inv(A62)*B62;
             [P62,MU62]=eig(M62);
             E62=sort(abs(diag(MU62)));
                 if sum(E62<1)==1 & sum(E62>1)==3;
                    minhelp=taupi;
                    maxhelp=taupi;
                 else
                    minhelp=10001;
                    maxhelp=-1;
                 end;
                 if minhelp<=L62(ty);
                    L62(ty)=minhelp;
                 end;
                 if maxhelp>=U62(ty);
                    U62(ty)=maxhelp;
                 end;
       end;
end;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%theta=1.05, Calvo
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%TAGGGGGGGGGGGGGGGGGGGGGGGGG
theta=1.05;
for ty=1:Ty;
    epsilon=4;
    ck=epsilon*deltatilde/(epsilon-1)/alpha/theta/rho-delta;
    lambdacalvo=(1-thetap)*(1-rho*thetap)/thetap/(1+epsilon*(1-theta)/theta);
    gammac=(deltatilde-1)*sigma-epsilonq*rho*ck;
    gamman=deltatilde*(eta+1)+epsilonq*rho*(1-alpha)*theta*(delta+ck);
    gammak=-deltatilde+epsilonq*rho*(alpha*theta*(delta+ck)-delta)-epsilonq;
    tauy=(ty-1)*0.05;
    L71(ty)=1;
    U71(ty)=1;
       for tpi=1:Tpi;
           taupi=(tpi-1)*0.01;
           minhelp=10000;
           maxhelp=0; 
             A71(1,1)=gammac;
             A71(1,2)=gammak;
             A71(1,3)=gamman;
             B71(1,1)=-sigma;
             B71(1,2)=-epsilonq;
             A71(2,2)=1;
             B71(2,1)=-ck;
             B71(2,2)=alpha*theta*(delta+ck)+1-delta;
             B71(2,3)=(1-alpha)*theta*(delta+ck);
             A71(3,4)=rho;
             B71(3,1)=-lambdacalvo*sigma;
             B71(3,2)=alpha*theta*lambdacalvo;
             B71(3,3)=-lambdacalvo*(1+eta-(1-alpha)*theta);
             B71(3,4)=1;
             A71(4,1)=sigma;
             A71(4,4)=1-taupi;
             B71(4,1)=sigma;
             B71(4,2)=alpha*theta*tauy;
             B71(4,3)=(1-alpha)*theta*tauy;
             M71=inv(A71)*B71;
             [P71,MU71]=eig(M71);
             E71=sort(abs(diag(MU71)));
                 if sum(E71<1)==1 & sum(E71>1)==3;
                    minhelp=taupi;
                    maxhelp=taupi;
                 else
                    minhelp=10001;
                    maxhelp=-1;
                 end;
                 if minhelp<=L71(ty);
                    L71(ty)=minhelp;
                 end;
                 if maxhelp>=U71(ty);
                    U71(ty)=maxhelp;
                 end;
       end;
end;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%theta=1.05, Rotemberg
for ty=1:Ty;
    epsilon=4;
   ck=epsilon*deltatilde/(epsilon-1)/alpha/theta/rho-delta;
    lamadarot=(epsilon-1)/gamma;
    gammac=(deltatilde-1)*sigma-epsilonq*rho*ck;
    gamman=deltatilde*(eta+1)+epsilonq*rho*(1-alpha)*theta*(delta+ck);
    gammak=-deltatilde+epsilonq*rho*(alpha*theta*(delta+ck)-delta)-epsilonq;
    tauy=(ty-1)*0.05;
    L72(ty)=1;
    U72(ty)=1;
       for tpi=1:Tpi;
           taupi=(tpi-1)*0.01;
           minhelp=10000;
           maxhelp=0; 
             A72(1,1)=gammac;
             A72(1,2)=gammak;
             A72(1,3)=gamman;
             B72(1,1)=-sigma;
             B72(1,2)=-epsilonq;
             A72(2,2)=1;
             B72(2,1)=-ck;
             B72(2,2)=alpha*theta*(delta+ck)+1-delta;
             B72(2,3)=(1-alpha)*theta*(delta+ck);
             A72(3,4)=rho;
             B72(3,1)=-lamadarot*sigma;
             B72(3,2)=alpha*theta*lamadarot;
             B72(3,3)=-lamadarot*(1+eta-(1-alpha)*theta);
             B72(3,4)=1;
             A72(4,1)=sigma;
             A72(4,4)=1-taupi;
             B72(4,1)=sigma;
             B72(4,2)=alpha*theta*tauy;
             B72(4,3)=(1-alpha)*theta*tauy;
             M72=inv(A72)*B72;
             [P72,MU72]=eig(M72);
             E72=sort(abs(diag(MU72)));
                 if sum(E72<1)==1 & sum(E72>1)==3;
                    minhelp=taupi;
                    maxhelp=taupi;
                 else
                    minhelp=10001;
                    maxhelp=-1;
                 end;
                 if minhelp<=L72(ty);
                    L72(ty)=minhelp;
                 end;
                 if maxhelp>=U72(ty);
                    U72(ty)=maxhelp;
                 end;
       end;
end;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
%theta=1.05, Calvo
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for ty=1:Ty;
    epsilon=10;
    ck=epsilon*deltatilde/(epsilon-1)/alpha/theta/rho-delta;
    lambdacalvo=(1-thetap)*(1-rho*thetap)/thetap/(1+epsilon*(1-theta)/theta);
    gammac=(deltatilde-1)*sigma-epsilonq*rho*ck;
    gamman=deltatilde*(eta+1)+epsilonq*rho*(1-alpha)*theta*(delta+ck);
    gammak=-deltatilde+epsilonq*rho*(alpha*theta*(delta+ck)-delta)-epsilonq;
    tauy=(ty-1)*0.05;
    L81(ty)=1;
    U81(ty)=1;
       for tpi=1:Tpi;
           taupi=(tpi-1)*0.01;
           minhelp=10000;
           maxhelp=0; 
             A81(1,1)=gammac;
             A81(1,2)=gammak;
             A81(1,3)=gamman;
             B81(1,1)=-sigma;
             B81(1,2)=-epsilonq;
             A81(2,2)=1;
             B81(2,1)=-ck;
             B81(2,2)=alpha*theta*(delta+ck)+1-delta;
             B81(2,3)=(1-alpha)*theta*(delta+ck);
             A81(3,4)=rho;
             B81(3,1)=-lambdacalvo*sigma;
             B81(3,2)=alpha*theta*lambdacalvo;
             B81(3,3)=-lambdacalvo*(1+eta-(1-alpha)*theta);
             B81(3,4)=1;
             A81(4,1)=sigma;
             A81(4,4)=1-taupi;
             B81(4,1)=sigma;
             B81(4,2)=alpha*theta*tauy;
             B81(4,3)=(1-alpha)*theta*tauy;
             M81=inv(A81)*B81;
             [P81,MU81]=eig(M81);
             E81=sort(abs(diag(MU81)));
                 if sum(E81<1)==1 & sum(E81>1)==3;
                    minhelp=taupi;
                    maxhelp=taupi;
                 else
                    minhelp=10001;
                    maxhelp=-1;
                 end;
                 if minhelp<=L81(ty);
                    L81(ty)=minhelp;
                 end;
                 if maxhelp>=U81(ty);
                    U81(ty)=maxhelp;
                 end;
       end;
end;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
%theta=1.05, Rotemberg
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for ty=1:Ty;
    epsilon=10;
    ck=epsilon*deltatilde/(epsilon-1)/alpha/theta/rho-delta;
    lamadarot=(epsilon-1)/gamma;
    gammac=(deltatilde-1)*sigma-epsilonq*rho*ck;
    gamman=deltatilde*(eta+1)+epsilonq*rho*(1-alpha)*theta*(delta+ck);
    gammak=-deltatilde+epsilonq*rho*(alpha*theta*(delta+ck)-delta)-epsilonq;
    tauy=(ty-1)*0.05;
    L82(ty)=1;
    U82(ty)=1;
       for tpi=1:Tpi;
           taupi=(tpi-1)*0.01;
           minhelp=10000;
           maxhelp=0; 
             A82(1,1)=gammac;
             A82(1,2)=gammak;
             A82(1,3)=gamman;
             B82(1,1)=-sigma;
             B82(1,2)=-epsilonq;
             A82(2,2)=1;
             B82(2,1)=-ck;
             B82(2,2)=alpha*theta*(delta+ck)+1-delta;
             B82(2,3)=(1-alpha)*theta*(delta+ck);
             A82(3,4)=rho;
             B82(3,1)=-lamadarot*sigma;
             B82(3,2)=alpha*theta*lamadarot;
             B82(3,3)=-lamadarot*(1+eta-(1-alpha)*theta);
             B82(3,4)=1;
             A82(4,1)=sigma;
             A82(4,4)=1-taupi;
             B82(4,1)=sigma;
             B82(4,2)=alpha*theta*tauy;
             B82(4,3)=(1-alpha)*theta*tauy;
             M82=inv(A82)*B82;
             [P82,MU82]=eig(M82);
             E82=sort(abs(diag(MU82)));
                 if sum(E82<1)==1 & sum(E82>1)==3;
                    minhelp=taupi;
                    maxhelp=taupi;
                 else
                    minhelp=10001;
                    maxhelp=-1;
                 end;
                 if minhelp<=L82(ty);
                    L82(ty)=minhelp;
                 end;
                 if maxhelp>=U82(ty);
                    U82(ty)=maxhelp;
                 end;
       end;
end;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
%theta=1.05, Calvo
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for ty=1:Ty;
    epsilon=20;
    ck=epsilon*deltatilde/(epsilon-1)/alpha/theta/rho-delta;
    lambdacalvo=(1-thetap)*(1-rho*thetap)/thetap/(1+epsilon*(1-theta)/theta);
    gammac=(deltatilde-1)*sigma-epsilonq*rho*ck;
    gamman=deltatilde*(eta+1)+epsilonq*rho*(1-alpha)*theta*(delta+ck);
    gammak=-deltatilde+epsilonq*rho*(alpha*theta*(delta+ck)-delta)-epsilonq;
    tauy=(ty-1)*0.05;
    L91(ty)=1;
    U91(ty)=1;
       for tpi=1:Tpi;
           taupi=(tpi-1)*0.01;
           minhelp=10000;
           maxhelp=0; 
            A91(1,1)=gammac;
             A91(1,2)=gammak;
             A91(1,3)=gamman;
             B91(1,1)=-sigma;
             B91(1,2)=-epsilonq;
             A91(2,2)=1;
             B91(2,1)=-ck;
             B91(2,2)=alpha*theta*(delta+ck)+1-delta;
             B91(2,3)=(1-alpha)*theta*(delta+ck);
             A91(3,4)=rho;
             B91(3,1)=-lambdacalvo*sigma;
             B91(3,2)=alpha*theta*lambdacalvo;
             B91(3,3)=-lambdacalvo*(1+eta-(1-alpha)*theta);
             B91(3,4)=1;
             A91(4,1)=sigma;
             A91(4,4)=1-taupi;
             B91(4,1)=sigma;
             B91(4,2)=alpha*theta*tauy;
             B91(4,3)=(1-alpha)*theta*tauy;
             M91=inv(A91)*B91;
             [P91,MU91]=eig(M91);
             E91=sort(abs(diag(MU91)));
                 if sum(E91<1)==1 & sum(E91>1)==3;
                    minhelp=taupi;
                    maxhelp=taupi;
                 else
                    minhelp=10001;
                    maxhelp=-1;
                 end;
                 if minhelp<=L91(ty);
                    L91(ty)=minhelp;
                 end;
                 if maxhelp>=U91(ty);
                    U91(ty)=maxhelp;
                 end;
       end;
end;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%theta=1.05, Rotemberg
for ty=1:Ty;
    epsilon=20;
    ck=epsilon*deltatilde/(epsilon-1)/alpha/theta/rho-delta;
    lamadarot=(epsilon-1)/gamma;
    gammac=(deltatilde-1)*sigma-epsilonq*rho*ck;
    gamman=deltatilde*(eta+1)+epsilonq*rho*(1-alpha)*theta*(delta+ck);
    gammak=-deltatilde+epsilonq*rho*(alpha*theta*(delta+ck)-delta)-epsilonq;
    tauy=(ty-1)*0.05;
    L92(ty)=1;
    U92(ty)=1;
       for tpi=1:Tpi;
           taupi=(tpi-1)*0.01;
           minhelp=10000;
           maxhelp=0; 
             A92(1,1)=gammac;
             A92(1,2)=gammak;
             A92(1,3)=gamman;
             B92(1,1)=-sigma;
             B92(1,2)=-epsilonq;
             A92(2,2)=1;
             B92(2,1)=-ck;
             B92(2,2)=alpha*theta*(delta+ck)+1-delta;
             B92(2,3)=(1-alpha)*theta*(delta+ck);
             A92(3,4)=rho;
             B92(3,1)=-lamadarot*sigma;
             B92(3,2)=alpha*theta*lamadarot;
             B92(3,3)=-lamadarot*(1+eta-(1-alpha)*theta);
             B92(3,4)=1;
             A92(4,1)=sigma;
             A92(4,4)=1-taupi;
             B92(4,1)=sigma;
             B92(4,2)=alpha*theta*tauy;
             B92(4,3)=(1-alpha)*theta*tauy;
             M92=inv(A92)*B92;
             [P92,MU92]=eig(M92);
             E92=sort(abs(diag(MU92)));
                 if sum(E92<1)==1 & sum(E92>1)==3;
                    minhelp=taupi;
                    maxhelp=taupi;
                 else
                    minhelp=10001;
                    maxhelp=-1;
                 end;
                 if minhelp<=L92(ty);
                    L92(ty)=minhelp;
                 end;
                 if maxhelp>=U92(ty);
                    U92(ty)=maxhelp;
                 end;
       end;
end;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ty=1:Ty;
omega=0.05*(ty-1);
subplot(3,2,1);
hold on
box on
plot(omega,U12(ty),'-*',omega,U22(ty),'-o',omega,U32(ty),'-^',omega,L12(ty),'-*',omega,L22(ty),'-o',omega,L32(ty),'-^');
ylabel('\theta=0.67');
axis([0,1,0,5]);
set(gca,'xtick',[0,0.2,0.4,0.6,0.8,1]);
set(gca,'ytick',[0,1,2,3,4,5]);
title('Rotemberg Model');

subplot(3,2,2);
hold on
box on
plot(omega,U11(ty),'-*',omega,U21(ty),'-o',omega,U31(ty),'-^',omega,L11(ty),'-*',omega,L21(ty),'-o',omega,L31(ty),'-^');
legend('\epsilon=4','\epsilon=10','\epsilon=20');
axis([0,1,0,5]);
set(gca,'xtick',[0,0.2,0.4,0.6,0.8,1]);
set(gca,'ytick',[0,1,2,3,4,5]);
title('Calvo Model');

subplot(3,2,3);
hold on
box on
plot(omega,U42(ty),'-*',omega,U52(ty),'-o',omega,U62(ty),'-^',omega,L42(ty),'-*',omega,L52(ty),'-o',omega,L62(ty),'-^');
ylabel('\theta=1');
axis([0,1,0,5]);
set(gca,'xtick',[0,0.2,0.4,0.6,0.8,1]);
set(gca,'ytick',[0,1,2,3,4,5]);

subplot(3,2,4);
hold on
box on
plot(omega,U41(ty),'-*',omega,U51(ty),'-o',omega,U61(ty),'-^',omega,L41(ty),'-*',omega,L51(ty),'-o',omega,L61(ty),'-^');
axis([0,1,0,5]);
set(gca,'xtick',[0,0.2,0.4,0.6,0.8,1]);
set(gca,'ytick',[0,1,2,3,4,5]);

subplot(3,2,5);
hold on
box on
plot(omega,U72(ty),'-*',omega,U82(ty),'-o',omega,U92(ty),'-^',omega,L72(ty),'-*',omega,L82(ty),'-o',omega,L92(ty),'-^');
ylabel('\theta=1.05');
axis([0,1,0,5]);
set(gca,'xtick',[0,0.2,0.4,0.6,0.8,1]);
set(gca,'ytick',[0,1,2,3,4,5]);

subplot(3,2,6);
hold on
box on
plot(omega,U71(ty),'-*',omega,U81(ty),'-o',omega,U91(ty),'-^',omega,L71(ty),'-*',omega,L81(ty),'-o',omega,L91(ty),'-^');
axis([0,1,0,5]);
set(gca,'xtick',[0,0.2,0.4,0.6,0.8,1]);
set(gca,'ytick',[0,1,2,3,4,5]);
